/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DISPATCHDATA_H
#define DISPATCHDATA_H

#include <gtkmm.h>

#include "VolumeDialog.h"

#include "Pline/Pline.h"

class VolumeGui;

class DispatchData
{
public:
	DispatchData();
	~DispatchData();
	
	DispatchData(void *p);
	
	void *getCaller() {return gpCaller;}
	
	// action
	inline void doPlineAskData(const bool b) {gbDoAskPline = b;}
	inline void doJoin(const bool b) {gbDoJoin = b;}
	inline void doShowDialog(const bool b) {gbDoShowDialog = b;}
	inline void doUpdateVolume(const bool b) {gbDoUpdateVolume = b;}
	
	// data
	inline void setDialogData(VolumeDialog::tConfig tConfig) {gtVolumeDialogConfig = tConfig;}
	inline void setPline(Pline::Pline *po) {gpoPline = po;}
	
	// volumegui handler
	inline VolumeGui* getVolumeGui() {return gpoVolumeGui;}
	inline void setVolumeGui(VolumeGui* poVolumeGui) {gpoVolumeGui = poVolumeGui;}
	
	// process
	bool isReqUserData();
	bool process();
	
	// signal
	inline sigc::signal<void>& signal_join() {return m_signal_join;}
	inline sigc::signal<void, Pline::Pline*>& signal_pline_askdata() {return m_signal_pline_askdata;}
	inline sigc::signal<void, VolumeDialog::tConfig>& signal_show_dialog() {return m_signal_show_dialog;}
	inline sigc::signal<void>& signal_update_volume() {return m_signal_update_volume;}
	
protected:

private:
	VolumeDialog::tConfig gtVolumeDialogConfig;
	Pline::Pline *gpoPline;
	VolumeGui *gpoVolumeGui;
	
	void *gpCaller;
	
	bool gbDoAskPline;
	bool gbDoJoin;
	bool gbDoShowDialog;
	bool gbDoUpdateVolume;
	
	sigc::signal<void>  m_signal_join;
	sigc::signal<void, Pline::Pline*>  m_signal_pline_askdata;
	sigc::signal<void, VolumeDialog::tConfig>  m_signal_show_dialog;
	sigc::signal<void>  m_signal_update_volume;
};
	
#endif /* DISPATCHDATA_H */
