/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ICON_H
#define ICON_H

#include <gtkmm.h>
#include <glib.h>

class Icon
{
public:
	Icon();
	~Icon();
	
	static Icon& getInstance();
	
	inline Glib::RefPtr<Gdk::Pixbuf> *drawBtnCancelDisabledIcon() {return gpoBtnCancelDisabledIcon;}
	inline Glib::RefPtr<Gdk::Pixbuf> *drawBtnCancelNormalIcon() {return gpoBtnCancelNormalIcon;}
	inline Glib::RefPtr<Gdk::Pixbuf> *drawBtnEjectNormalIcon() {return gpoBtnEjectNormalIcon;}
	inline Glib::RefPtr<Gdk::Pixbuf> *drawBtnMountDisabledIcon() {return gpoBtnMountDisabledIcon;}
	inline Glib::RefPtr<Gdk::Pixbuf> *drawBtnMountNormalIcon() {return gpoBtnMountNormalIcon;}
	
	inline Glib::RefPtr<Gdk::Pixbuf> *drawSysIcon16() {return gpoSysIcon16;}
	inline Glib::RefPtr<Gdk::Pixbuf> *drawSysIcon32() {return gpoSysIcon32;}
	inline Glib::RefPtr<Gdk::Pixbuf> *drawSysIcon64() {return gpoSysIcon64;}
	
protected:

private:
	bool gbErrorMsgShown;
	
	Glib::RefPtr<Gdk::Pixbuf> *gpoBtnCancelDisabledIcon;
	Glib::RefPtr<Gdk::Pixbuf> *gpoBtnCancelNormalIcon;
	Glib::RefPtr<Gdk::Pixbuf> *gpoBtnEjectNormalIcon;
	Glib::RefPtr<Gdk::Pixbuf> *gpoBtnMountDisabledIcon;
	Glib::RefPtr<Gdk::Pixbuf> *gpoBtnMountNormalIcon;
	Glib::RefPtr<Gdk::Pixbuf> *gpoSysIcon16;
	Glib::RefPtr<Gdk::Pixbuf> *gpoSysIcon32;
	Glib::RefPtr<Gdk::Pixbuf> *gpoSysIcon64;
	
	Glib::RefPtr<Gdk::Pixbuf> *drawIcon(	std::string stFilename,
											const guint8 *pixel_data,
											const int data_width,
											const int data_height,
											const int iWidth, 
											const int iHeight);
};
	
#endif /* ICON_H */
