/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MOUNTDIALOG_H
#define MOUNTDIALOG_H

#include "QDialog.h"
#include "UtilGui.h"

#include <gtkmm.h>

class DialogHelper;
class VolumeConfig;

class MountDialog : public QDialog
{
public:
	MountDialog(BaseObjectType* cobject,
				const Glib::RefPtr<Gtk::Builder>& refGlade);
	~MountDialog();

	void setData(   VolumeConfig *poVolumeConfig,
					std::vector<Glib::ustring> *pvecVolumeConfigLabel,
					const Glib::ustring& stSrc = "");

	inline bool isAddOnly() {return gbAddOnly;}
	
protected:
	
private:
	UtilGui::tMountDlg gtMountDlg;
	DialogHelper *gpoDialogHelper;
	
	bool gbAddOnly;
	
	Gtk::FileChooserButton* gpoSourceFileChooser;
	
	// data
	VolumeConfig *gpoVolumeConfig;	
	std::vector<Glib::ustring> *gpvecVolumeConfigLabel;
	std::vector<Glib::ustring> gvecFSys;
	
	void buildFSys();

	void onAdd();
	void onCancel();
	void onEncrypt();
	void onMount();
	void onPermissions();
	void onReadOnly();
	void onSource();
	void onUseKeyFile();
	void onUsePassword();

	void updateData(const bool bToScreen);
	bool validate();
};
	
#endif /* MOUNTDIALOG_H */
