/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MsgDialog.h"
#include "QDebug.h"

#include <glibmm/i18n.h>

//==============================================================================

MsgDialog::MsgDialog(const tConfig& tConfigItem)
: QDialog(getQDialogConfig(tConfigItem))
{
	// vbox
	Gtk::VBox* vbox = QDialog::getVBox();
	
	Gtk::Label* label = manage(new Gtk::Label(tConfigItem.stMsg, 0.0, 0.0));
	label->set_alignment(0.5);
	label->set_use_markup(true);
	label->set_line_wrap(false);

	vbox->pack_start(*label, false, false, 12);
			
	// ok button
	if (tConfigItem.bYesNo)
	{
		add_button(Gtk::Stock::NO, Gtk::RESPONSE_CANCEL);
		add_button(Gtk::Stock::YES, Gtk::RESPONSE_OK);
	}
	else
		add_button(Gtk::Stock::OK, Gtk::RESPONSE_OK);
	
	show_all();
	
	if (tConfigItem.bAutoRun)
		run();
}

//==============================================================================

MsgDialog::~MsgDialog()
{
}

//==============================================================================

QDialog::tConfig MsgDialog::getQDialogConfig(const tConfig& tConfigItem)
{
	QDialog::tConfig tQDialogConfigItem;
	QDialog::initConfig(tQDialogConfigItem);
	
	tQDialogConfigItem.poParent = tConfigItem.poParent;
	tQDialogConfigItem.stTitle = tConfigItem.stTitle;
	tQDialogConfigItem.bWaitData = tConfigItem.bWaitData;
	
	return tQDialogConfigItem;
}

//==============================================================================

void MsgDialog::initConfig(tConfig& tConfigItem)
{
	tConfigItem.poParent = 0;
	tConfigItem.bAutoRun = true;
	tConfigItem.bWaitData = true;
	tConfigItem.bYesNo = false;
	tConfigItem.stTitle = _("Message");
	tConfigItem.stMsg.clear();
}

//==============================================================================
