/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PERMDIALOG_H
#define PERMDIALOG_H

#include "QDialog.h"
#include "UtilGui.h"

#include <gtkmm.h>
#include <sys/stat.h>

#include "Pline/MountData.h"

class PermDialog : public QDialog
{
public:
	PermDialog( BaseObjectType* cobject,
				const Glib::RefPtr<Gtk::Builder>& refGlade);
	~PermDialog();

	void setData(Pline::MountData *poMountData);

public:
	typedef enum _PERM_
	{
		kPermOwner,
		kPermGroup,
		kPermOther,
	}
	ePerm;

protected:

private:
	UtilGui::tPermDlg gtPermDlg;
	Pline::MountData *gpoMountData;
	
	std::vector<Glib::ustring>  gvecUserName;
	std::vector<int>			gvecUserID;
	std::vector<Glib::ustring>  gvecGroupName;
	std::vector<int>			gvecGroupID;

	typedef struct _PERMSTRUCT_
	{
		enum _PERM_			ePerm;
		Glib::ustring		stPerm;
		mode_t 				tMode;
		Gtk::ComboBoxText	*pocmb;
	}
	tPerm;
	std::vector<tPerm> gvecPerm;
	
	void buildPerm();
	void buildUsers();
	
	void onClose();
	void onSetPerm();
	
	void enablePerm(const bool bEnable);
	void updateData(const bool bToScreen);
	void updatePerm(const mode_t tMode = 0);
	void updateUser(const Glib::ustring stUserName = "",
					const Glib::ustring stGroupName = "");
};
	
#endif /* PERMDIALOG_H */
