/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "CryptData.h"
#include "QDebug.h"

namespace Pline
{

//==============================================================================

CryptData::CryptData(const Data &oData)
: Data(oData)
{
	init();
}

//==============================================================================

CryptData::~CryptData()
{
}

//==============================================================================

CryptData* CryptData::operator=(const CryptData &oCryptData)
{
	gbEncrypted = oCryptData.gbEncrypted;
	gstKeyFile = oCryptData.gstKeyFile;
	
	return this;
}

//==============================================================================

bool CryptData::operator==(const CryptData &oCryptData) const
{
	if (gbEncrypted == oCryptData.gbEncrypted
		&& gstKeyFile == oCryptData.gstKeyFile)
	{
		return true;
	}
	
	return false;
}

//==============================================================================

bool CryptData::operator!=(const CryptData &oCryptData) const
{	
	return !((*this).operator==(oCryptData));
}

//==============================================================================

void CryptData::init()
{
	gbEncrypted = false;
}

//==============================================================================

} // Pline
