/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MOUNTFILTER_H
#define MOUNTFILTER_H

#include "MountBaseFilter.h"
#include "MountData.h"

#include <gtkmm.h>

namespace Pline
{

class MountFilter : public MountBaseFilter
{
public:
	MountFilter();
	virtual ~MountFilter();
	
	// ready to enter data
	void askData();

	// filter config
	inline const Glib::ustring getFilterName() const {return "Mount";}

	// data
	void setSrcData(MountData *poData);
	
	// base path src is used to validate the mount point
	// it must point to the first filter added generally, the filter including
	// the orignal path of the source to be mounted
	void setBasePathSrc(Data *poData);
	
	// run
	bool isAttached();
		
protected:
	bool attach();
	bool detach();
	bool probe();

private:
	MountData *gpoMountData;
	Data *gpoSrcPathData;
	
	bool isValidMountPoint();
};

} // Pline	
#endif /* MOUNTFILTER_H */
