/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PROGRESSDIALOG_H
#define PROGRESSDIALOG_H

#include <gtkmm.h>
#include "QDialog.h"

class ProgressDialog : public QDialog
{
public:
	typedef struct _CONFIG_
	{
		bool bAutoShow;
		bool bWaitData;
		Glib::ustring stTitle;
		Glib::ustring stMsg;
	}
	tConfig;
	
	static void initConfig(tConfig& tConfigItem);
	
public:
	ProgressDialog(const tConfig& tConfigItem);
	~ProgressDialog();
	
	bool update(const double dFraction,
				const Glib::ustring& stMsg);
	
protected:

private:
	Gtk::Label*			gpoMsgLabel;
	Gtk::ProgressBar*   gpoProgressBar;
	bool				gbCancel;
	
	static QDialog::tConfig getQDialogConfig(const tConfig& tConfigItem);

	void onCancel();
};
	
#endif /* MSGDIALOG_H */
